<p align="center">
  <img src="https://github.com/BBasile/Coedit/raw/master/logo/coedit.png?raw=true" width="15%" height="15%" alt="CE"/>
</p>

Coedit is an IDE for the [D programming language](http://dlang.org), its compilers, tools and libraries.

[![](https://github.com/BBasile/CoeditWikiData/raw/master/coedit.win7.33.png)](https://github.com/BBasile/CoeditWikiData/raw/master/coedit.win7.png)

[![](https://www.paypalobjects.com/en_US/i/btn/btn_donateCC_LG.gif)](https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=AQDJVC39PJF7J)

**Features overview**
---
- multi platform (_Windows_, _Linux_).
- comprehensive project format and two advanced project editors (one for the options and configurations, another for the files).
- DUB projects are supported too, with a an editor for the properties and an inspector to view and select sources or configurations.
- all the D compilers are supported.
- compile and run directly from the UI.
- single click to compile and execute an unsaved module (aka a _runnable module_).
- single click to compile and _unittest_ a module.
- advanced editor with D2 syntax highlighter, folds, regions, identifier markup, macros, sync-edit, etc.
- edition helpers: comment blocks, local identifier renaming, brace auto-closing, etc.
- list of the symbols in the module being edited.
- static libraries manager that supports auto-registration from local DUB projects, from online DUB packages or from Coedit custom project format.
- _todo comments_ parser and dedicated widget.
- user-defined tools powered by a string interpolation system.
- full [D Completion Daemon](https://github.com/Hackerpilot/DCD) integration (completion, hints, call tips, jump to symbol declaration).
- mini file browser, dfmt interface, search & replace, etc.
- [selection of 3rd party libraries](https://github.com/BBasile/metad) that can be easily build and integrated in Coedit.

**Project information**
---
- latest stable release: version 2, update 6, Fri May 27 2016.
- latest beta release: version 3, beta 2, Sat Dec 24 2016.
- licensed under the terms of the Boost license.

**Download version 3 beta 2**
---
Download the zipped binaries or the zipped setup program for you platform:

- :package: [setup program for Linux 32 bit](https://github.com/BBasile/Coedit/releases/download/3_beta_2/coedit.3beta2.linux32.setup.zip)
- :package: [binaries for Linux 32 bit](https://github.com/BBasile/Coedit/releases/download/3_beta_2/coedit.3beta2.linux32.zip)
- :package: [setup program for Linux 64 bit](https://github.com/BBasile/Coedit/releases/download/3_beta_2/coedit.3beta2.linux64.setup.zip)
- :package: [binaries for Linux 64 bit](https://github.com/BBasile/Coedit/releases/download/3_beta_2/coedit.3beta2.linux64.zip)
- :package: [setup program for Windows 32/64 bit](https://github.com/BBasile/Coedit/releases/download/3_beta_2/coedit.3beta2.win32.setup.zip)
- :package: [binaries for Windows 32/64 bit](https://github.com/BBasile/Coedit/releases/download/3_beta_2/coedit.3beta2.win32.zip)
- :package: [rpm for Linux 64 bit](https://github.com/BBasile/Coedit/releases/download/3_beta_2/coedit-3-beta2.x86_64.rpm)

**Download version 2 update 6**
---
Download the zipped binaries or the zipped setup program for you platform:

- :package: [setup program for Linux 32 bit](https://github.com/BBasile/Coedit/releases/download/2_update_6/coedit.2update6.linux32.setup.zip)
- :package: [binaries for Linux 32 bit](https://github.com/BBasile/Coedit/releases/download/2_update_6/coedit.2update6.linux32.zip)
- :package: [setup program for Linux 64 bit](https://github.com/BBasile/Coedit/releases/download/2_update_6/coedit.2update6.linux64.setup.zip)
- :package: [binaries for Linux 64 bit](https://github.com/BBasile/Coedit/releases/download/2_update_6/coedit.2update6.linux64.zip)
- :package: [setup program for Windows 32/64 bit](https://github.com/BBasile/Coedit/releases/download/2_update_6/coedit.2update6.win32.setup.zip)
- :package: [binaries for Windows 32/64 bit](https://github.com/BBasile/Coedit/releases/download/2_update_6/coedit.2update6.win32.zip)
- :package: [rpm for Linux 64 bit](https://github.com/BBasile/Coedit/releases/download/2_update_6/coedit-2-update6.x86_64.rpm)

[**See the wiki**](https://github.com/BBasile/Coedit/wiki#detailed-setup-procedure) for more information about the setup. 

**Build**
---

- 2 update 6: The procedure is described in the [**first section of the wiki**](https://github.com/BBasile/Coedit/wiki#detailed-setup-procedure)
- 3 beta (master): Confers with this [**temporary document**](https://github.com/BBasile/Coedit/wiki/Building-and-using-the-developpement-version)

**GUI preview**
---
Windows version (Windows 7, x86):
![Win screen-cap](https://github.com/BBasile/CoeditWikiData/raw/master/coedit.win7.png "Coedit GUI preview")

Linux version (OpenSuse 13.2, KDE, x86_64):
![Nux screen-cap](https://github.com/BBasile/CoeditWikiData/raw/master/coedit.linux.kde.png "Coedit GUI preview")

Linux version (Mint 17.1, Cinnamon, x86):
![Nux screen-cap](https://github.com/BBasile/CoeditWikiData/raw/master/coedit.linux.cinnamon.png "Coedit GUI preview")